<?
/* 
 * EDOMI beta (Version 1.56) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");


sql_connect();

if (checkAdmin($sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$winId,$data,$dataArr,$phpdata,$phpdataArr,$sid;


	if ($cmd=='initApp') {

		//Existiert ein aktuelles Live-Projekt?
		if (getLiveProjektId()===false) {
?>
			closeWindow("<?echo $winId;?>");
			jsConfirm("Es ist kein Live-Projekt vorhanden.","","none");
<?
			return;
		}

		//Defaultwerte
		$phpdataArr[0]='';															//Startdatum (das größere Datum)
		$phpdataArr[1]='';															//Enddatum (das kleinere Datum)
		$phpdataArr[2]=50;															//Zoom (Bildbreite in Pixeln)
		$phpdataArr[3]=0;															//Modus (0=normal, 1=Millisekundengenau)
		$phpdataArr[4]=str_repeat('1',sql_getCount('edomiLive.archivCam','1=1'));	//Mute/Solo-String (per Default alle Archive anzeigen)
		$phpdataArr[5]=2;															//Zeitraum (hier: die letzten 7 Tage)

		//Fenster aufbauen
?>
		var n="<div class='appWindowFullscreen'>";
			n+="<div class='appTitel'>Kameraarchivansicht<div class='cmdHelp' onClick='openWindow(9999,\"<?echo $appId;?>\");'>?</div></div>";
			n+="<div id='<?echo $winId;?>-main'></div>";
			n+="<div id='<?echo $winId;?>-edit' style='position:absolute; left:5px; top:80px; right:5px; bottom:5px; padding:0; border-radius:3px; overflow:auto; background:#343434;'></div>";
		n+="</div>";
		document.getElementById("<?echo $winId;?>").innerHTML=n;

		var n="<div id='<?echo $winId;?>-form1' class='appMenu'>";
			n+="<div class='cmdButton' onClick='closeWindow(\"<?echo $winId;?>\");'>Schliessen</div>&nbsp;&nbsp;&nbsp;";
			n+="<input type='hidden' id='<?echo $winId;?>-fd4' data-type='1' value='<?echo $phpdataArr[4];?>' class='control1'></input>";
			
			n+="<div id='<?echo $winId;?>-fd3' onChange='ajax(\"start\",\"<?echo $appId;?>\",\"<?echo $winId;?>\",\"<?echo $data;?>\",controlGetFormData(\"<?echo $winId;?>-form1\"));' data-type='6' data-value='<?echo $phpdataArr[3];?>' data-list='0|normale Anzeige;1|präzise Anzeige;2|präzise Anzeige (überlappend);' class='control6' style='min-width:120px; height:27px;'>&nbsp;</div>&nbsp;&nbsp;&nbsp;";
			n+="<div id='<?echo $winId;?>-fd5' onChange='ajax(\"start\",\"<?echo $appId;?>\",\"<?echo $winId;?>\",\"<?echo $data;?>\",controlGetFormData(\"<?echo $winId;?>-form1\"));' data-type='6' data-value='<?echo $phpdataArr[5];?>' data-list='0|Datumsbereich|<?echo $winId;?>-radio0;1|alle Bilder;2|letzten 7 Tage;3|letzten 14 Tage;4|letzter Monat;5|letzten 3 Monate;6|letzten 6 Monate;7|letzten 12 Monate;' class='control6' style='min-width:120px; height:27px;'>&nbsp;</div>";
			n+="<div id='<?echo $winId;?>-radio0' style='vertical-align:middle;'>";
				n+="&nbsp;von <input type='text' id='<?echo $winId;?>-fd0' data-type='1' value='<?echo $phpdataArr[0];?>' class='control1' style='height:27px; vertical-align:top;'></input>&nbsp;bis&nbsp;";
				n+="<input type='text' id='<?echo $winId;?>-fd1' data-type='1' value='<?echo $phpdataArr[1];?>' class='control1' style='height:27px; vertical-align:top;'></input>";
			n+="</div>";

			n+="<div style='vertical-align:middle; float:right;'>";
				n+="<input type='range' id='<?echo $winId;?>-fd2' data-type='1' value='<?echo $phpdataArr[2];?>' min='50' max='200' step='10' onChange='ajax(\"start\",\"<?echo $appId;?>\",\"<?echo $winId;?>\",\"<?echo $data;?>\",controlGetFormData(\"<?echo $winId;?>-form1\"));' style='width:120px; vertical-align:middle;'></input>&nbsp;&nbsp;&nbsp;";
				n+="&nbsp;&nbsp;&nbsp;<div class='cmdButton' onClick='ajax(\"start\",\"<?echo $appId;?>\",\"<?echo $winId;?>\",\"<?echo $data;?>\",controlGetFormData(\"<?echo $winId;?>-form1\"));'>Aktualisieren</div>";
			n+="</div>";
			
		n+="</div>";
		document.getElementById("<?echo $winId;?>-main").innerHTML=n;
		controlInitAll("<?echo $winId;?>-form1");
<?
		cmd('start');
	}


	if ($cmd=='start') {
		//Gesamtanzahl der Bilder
		$archivesDataCount=sql_getCount('edomiLive.archivCamData','1=1');

		if ($phpdataArr[5]==0) {
			//Datumsbereich: Manuell
			if (!strtotime($phpdataArr[0])) {$phpdataArr[0]=date('d.m.Y');}
			if (!strtotime($phpdataArr[1])) {$phpdataArr[1]=date('d.m.Y');}
			//Datum ggf. vertauschen		
			if (strtotime($phpdataArr[1])>strtotime($phpdataArr[0])) {
				$tmp=$phpdataArr[0];
				$phpdataArr[0]=$phpdataArr[1];
				$phpdataArr[1]=$tmp;
			}
?>
			document.getElementById("<?echo $winId;?>-fd0").value="<?echo $phpdataArr[0];?>";
			document.getElementById("<?echo $winId;?>-fd1").value="<?echo $phpdataArr[1];?>";
<?
		} else {
			//Datumsbereich: Vorgaben
			$phpdataArr[0]=date('d.m.Y');
			if ($phpdataArr[5]==1) {$phpdataArr[1]=date('d.m.Y',0);}
			if ($phpdataArr[5]==2) {$phpdataArr[1]=date('d.m.Y',strtotime('today -7 day'));}
			if ($phpdataArr[5]==3) {$phpdataArr[1]=date('d.m.Y',strtotime('today -14 day'));}
			if ($phpdataArr[5]==4) {$phpdataArr[1]=date('d.m.Y',strtotime('today -1 month'));}
			if ($phpdataArr[5]==5) {$phpdataArr[1]=date('d.m.Y',strtotime('today -3 month'));}
			if ($phpdataArr[5]==6) {$phpdataArr[1]=date('d.m.Y',strtotime('today -6 month'));}
			if ($phpdataArr[5]==7) {$phpdataArr[1]=date('d.m.Y',strtotime('today -12 month'));}
		}


		//Legenden
		//-----------------------------------------
?>
		var n="";
		var nArchiv={};

		n+="<table width='100%' border='0' cellpadding='0' cellspacing='1' style='table-layout:auto;'>";
			n+="<tr>";
				n+="<td width='1'>&nbsp;</td>";
				n+="<td><div id='<?echo $winId;?>-date' style='position:relative; left:0; top:0; height:24px; color:#ffffff;'></div></td>";
			n+="</tr>";
			n+="<tr><td colspan='2'><div style='width:100%; height:1px; margin:0 0 5px 0; background:#505050;'></div></td></tr>";
<?
		$archivSqlFilter='';
		$archivIndex=0;
		$old_folderId=-1;
		$ss1=sql_call("SELECT * FROM edomiLive.archivCam ORDER BY folderid ASC,id ASC");
		while ($n=sql_result($ss1)) {

			$muted=false;
			$solo=false;
			if (substr($phpdataArr[4],$archivIndex,1)=='0') {
				$archivSqlFilter.='targetid<>'.$n['id'].' AND ';
				$muted=true;
			} else if (substr($phpdataArr[4],$archivIndex,1)=='2') {
				$muted=false;
				$solo=true;
			}

			$anz1=sql_getCount('edomiLive.archivCamData','targetid='.$n['id']);
			if ($archivesDataCount>0) {$anz2=round(($anz1/$archivesDataCount)*100,1);} else {$anz2=0;}

			//Ordner anzeigen
			if ($old_folderId!=$n['folderid']) {
				if ($n['folderid']>=1000) {
					$tmp=sql_getValue('edomiLive.root','name','id='.$n['folderid']);
?>
					n+="<tr><td colspan='2' style='padding:0 0 5px 7px; color:#7070ff;'><?ajaxEcho($tmp);?></td></tr>";
					n+="<tr><td colspan='2'><div style='width:100%; height:1px; margin:0px 0 5px 0; background:#7070ff;'></div></td></tr>";
<?
				}
				$old_folderId=$n['folderid'];
			}
			
			//Archive anzeigen
?>
			nArchiv["<?echo $n['id'];?>"]="";
			n+="<tr valign='top'>";
				n+="<td>";
					n+="<div style='padding:1px 5px 1px 5px; color:#ffffff;'>";
						n+="<table width='170' border='0' cellpadding='0' cellspacing='2' style='table-layout:auto;'>";
							n+="<tr>";
								n+="<td><div style='max-width:135px; white-space:nowrap; overflow:hidden; vertical-align:bottom;'><?ajaxEcho($n['name']);?> <span class='id' style='color:#343434;'><?echo $n['id'];?></span></div></td>";
								n+="<td width='15' align='right'><div class='cmdButtonSmall' onClick='app102_toggle(<?echo $archivIndex;?>,2,\"<?echo $winId;?>\");' style='width:15px; <?if ($solo) {echo 'background:#ffff00;';}?>'>S</div></td>";
							n+="</tr>";
							n+="<tr>";
								n+="<td><div style='width:100%; height:2px; border-radius:2px; background:-webkit-linear-gradient(left,#c0c0c0 0%,#c0c0c0 <?echo $anz2;?>%,#505050 <?echo $anz2;?>%,#505050 100%);'></div></td>";
								n+="<td><div style='width:1px; height:1px;'></div></td>";
							n+="</tr>";
							n+="<tr>";
								n+="<td style='color:#a0a0a0;'><?echo $anz1;?> Bilder</td>";
								n+="<td width='15' align='right'><div class='cmdButtonSmall' onClick='app102_toggle(<?echo $archivIndex;?>,1,\"<?echo $winId;?>\");' style='width:15px; <?if (!$muted) {echo 'background:#80e000;';}?>'>&equiv;</div></td>";
							n+="</tr>";
						n+="</table>";
					n+="</div>";
				n+="</td>";
				n+="<td><div id='<?echo $winId;?>-archivimg<?echo $n['id'];?>' style='position:relative; left:0; top:0; height:100%; vertical-align:top; display:inline-block; cursor:pointer;'></div></td>";
			n+="</tr>";
			n+="<tr><td colspan='2'><div style='width:100%; height:1px; margin:5px 0 5px 0; background:#505050;'></div></td></tr>";
<?
			$archivIndex++;
		}
		
		$archivSqlFilter.='1=1';
?>
		n+="</table>";

		document.getElementById("<?echo $winId;?>-edit").innerHTML=n;
		controlInitAll("<?echo $winId;?>-form1");
<?


		//Bilder und Datum/Zeit
		//-----------------------------------------
?>
		var nDate="";
<?
		$x=0;
		$dateOld='';
		$ss1=sql_call("SELECT datetime,ms FROM edomiLive.archivCamData WHERE (".$archivSqlFilter." AND DATE(datetime)>='".date('Y-m-d',strtotime($phpdataArr[1]))."' AND DATE(datetime)<='".date('Y-m-d',strtotime($phpdataArr[0]))."') GROUP BY datetime ORDER BY datetime DESC,ms DESC");
		while ($n=sql_result($ss1)) {

			if (substr($n['datetime'],0,10)!=$dateOld) {
				//Datum und Uhrzeit
?>
				nDate+="<div style='position:absolute; left:<?echo intval($x);?>px; top:0px; height:12px; padding:0 2px 0 1px; border-left:1px solid #ffff00; border-radius:0 3px 3px 0; color:#000000; background:#ffff00;'><?echo sql_getDate($n['datetime']);?></div>";
				nDate+="<div style='position:absolute; left:<?echo intval($x);?>px; top:12px; height:12px; padding-left:1px; border-left:1px solid #ffff00;'><?echo sql_getTime($n['datetime']);?></div>";
<?
				$dateOld=substr($n['datetime'],0,10);
			} else {
				//nur Uhrzeit
?>
				nDate+="<div style='position:absolute; left:<?echo intval($x);?>px; top:12px; height:12px; padding-left:1px; border-left:1px solid #a0a0a0;'><?echo sql_getTime($n['datetime']);?></div>";
<?
			}

			$maxWidth=0;
			if ($phpdataArr[3]==0) {
				//----------------------------
				//Normal
				//----------------------------
				$oldId=0;
				$xx=0;
				$ss2=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (".$archivSqlFilter." AND datetime='".$n['datetime']."') ORDER BY targetid DESC,ms DESC");
				while ($nn=sql_result($ss2)) {
					if ($oldId!=$nn['targetid']) {
						$xx=0;
						$oldId=$nn['targetid'];
					}
					if ($nn['width1']>0) {
						//Thumbnail vorhanden
						$imgThumbHeight=truncFloat($phpdataArr[2]*($nn['height1']/$nn['width1']));
						$fn='../data/liveproject/cam/archiv/'.getArchivCamFilename($nn['targetid'],$nn['camid'],$nn['datetime'],$nn['ms']).'-1.jpg';
					} else {
						//kein Thumbnail vorhanden => normales Bild nehmen
						$imgThumbHeight=truncFloat($phpdataArr[2]*($nn['height0']/$nn['width0']));
						$fn='../data/liveproject/cam/archiv/'.getArchivCamFilename($nn['targetid'],$nn['camid'],$nn['datetime'],$nn['ms']).'.jpg';
					}
?>
					nArchiv["<?echo $nn['targetid'];?>"]+="<img src='<?echo $fn;?>' onClick='openWindow(1014,\"<?echo AJAX_SEPARATOR1;?><?echo $nn['targetid'];?><?echo AJAX_SEPARATOR1;?><?echo $nn['datetime'];?><?echo AJAX_SEPARATOR1;?><?echo $nn['ms'];?><?echo AJAX_SEPARATOR1;?>\");' style='position:absolute; left:<?echo intval($x+$xx);?>px; top:0; width:<?echo ($phpdataArr[2]-1);?>px; height:<?echo ($imgThumbHeight-1);?>px;'>";
<?
					if (($xx+$phpdataArr[2])>$maxWidth) {$maxWidth=($xx+$phpdataArr[2]);}
					$xx+=$phpdataArr[2];
				}

			} else {	
				//----------------------------
				//Millisekundengenau
				//----------------------------
				$ss2=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (".$archivSqlFilter." AND datetime='".$n['datetime']."') ORDER BY targetid DESC,ms ASC");
				while ($nn=sql_result($ss2)) {
					if ($nn['width1']>0) {
						//Thumbnail vorhanden
						$imgThumbHeight=truncFloat($phpdataArr[2]*($nn['height1']/$nn['width1']));
						$fn='../data/liveproject/cam/archiv/'.getArchivCamFilename($nn['targetid'],$nn['camid'],$nn['datetime'],$nn['ms']).'-1.jpg';
					} else {
						//kein Thumbnail vorhanden => normales Bild nehmen
						$imgThumbHeight=truncFloat($phpdataArr[2]*($nn['height0']/$nn['width0']));
						$fn='../data/liveproject/cam/archiv/'.getArchivCamFilename($nn['targetid'],$nn['camid'],$nn['datetime'],$nn['ms']).'.jpg';
					}
					$xx=truncFloat(((999999-$nn['ms'])/999999)*$phpdataArr[2]);
?>
					nArchiv["<?echo $nn['targetid'];?>"]+="<img src='<?echo $fn;?>' onClick='openWindow(1014,\"<?echo AJAX_SEPARATOR1;?><?echo $nn['targetid'];?><?echo AJAX_SEPARATOR1;?><?echo $nn['datetime'];?><?echo AJAX_SEPARATOR1;?><?echo $nn['ms'];?><?echo AJAX_SEPARATOR1;?>\");' style='position:absolute; left:<?echo intval($x+($xx*$phpdataArr[3]));?>px; top:0; width:<?echo ($phpdataArr[2]-1);?>px; height:<?echo ($imgThumbHeight-1);?>px; border-right:1px solid #252525;'>";
<?
					if (($xx+$phpdataArr[2])>$maxWidth) {$maxWidth=($xx+$phpdataArr[2]);}
				}
			}
			$x+=$maxWidth;
		}


		//Ausgabe
		//-----------------------------------------
?>
		var empty=true;
		for (var key in nArchiv) {
			document.getElementById("<?echo $winId;?>-archivimg"+key).innerHTML=nArchiv[key];
			document.getElementById("<?echo $winId;?>-archivimg"+key).style.width=document.getElementById("<?echo $winId;?>-archivimg"+key).scrollWidth+"px";
			document.getElementById("<?echo $winId;?>-archivimg"+key).style.height=document.getElementById("<?echo $winId;?>-archivimg"+key).scrollHeight+"px";
			empty=false;
		}
		if (!empty) {		
			document.getElementById("<?echo $winId;?>-date").style.display="block";
			document.getElementById("<?echo $winId;?>-date").innerHTML=nDate;
			document.getElementById("<?echo $winId;?>-date").style.width=document.getElementById("<?echo $winId;?>-date").scrollWidth+"px";
		} else {
			document.getElementById("<?echo $winId;?>-date").style.display="none";
		}
<?
	}

}

sql_disconnect();


?>

