###[DEF]###
[name			=Virtuelle Leuchte		]

[e#1 TRIGGER	=A: Lichtwert (Alarm)	]
[e#2 TRIGGER	=B: Lichtwert			]
[e#3 TRIGGER	=C: 0/1 (Automatik)		]
[e#4 TRIGGER	=D: 0/1					]
[e#5 TRIGGER	=E: 0/1 (Timer)			]

[e#6 IMPORTANT	=Typ #init=0 			]
[e#7 IMPORTANT	=Hauptschalter #init=1	]
[e#8 			=Sparmodus #init=0		]
[e#9 			=Hell/Dunkel 			]

[e#10 			=B: Aktiviert #init=1	]
[e#11 			=D: Aktiviert #init=1	]
[e#12 			=E: Aktiviert #init=1	]
[e#13 OPTION	=C: Lichtwert			]
[e#14 OPTION	=D: Lichtwert			]
[e#15 OPTION	=E: Lichtwert			]
[e#16 OPTION	=E: Dauer (s) #init=0	]


[a#1		=Lichtwert					]
[a#2		=Status						]
[a#3		=Status	A					]
[a#4		=Status	B					]
[a#5		=Status	C					]
[a#6		=Status	D					]
[a#7		=Status	E					]


[v#1		=							] aktueller Lichtwert an A1 (für SBC)
[v#2		=0							] Statusbyte
[v#3		=-1							] Status A3..A7 (für SBC)
[v#4		=0							] Timer für E
###[/DEF]###


###[HELP]###
Dieser Baustein kann auf vielfältige Weise eine Leuchte ansteuern und ersetzt somit eine entsprechend komplexe Logik.

An den Eingängen E1 und E2 werden "Lichtwerte" erwartet: Ein Lichtwert kann im einfachsten Fall 0/1 sein (Aus/Ein), je nach Typ (E6) jedoch auch z.B. ein HSV-Wert wie "A1B2C3".
Die Eingänge E3, E4 und E5 erwarten hingegen stets eine 0 (Aus) oder eine 1 (Ein) - der zugehörige Lichtwert wird an E13, E14 und E15 definiert (je nach Typ an E6).

Grundsätzlich werden 2 Zustände an E1..E5 unterschieden: Ein Lichtwert für "EIN" und ein Lichtwert für "AUS" (bzw. 1/0 an E3, E4 und E5).
"EIN" führt stets dazu, dass alle nachfolgenden(!) Eingänge blockiert werden (s.u.), während "AUS" die nachfolgenden Eingänge wieder freigibt.
"EIN" setzt A1 ggf. auf einen Lichtwert, der eine eingeschaltete Leuchte repräsentiert, während "AUS" das Gegenteil bewirkt (Leuchte wird ausgeschaltet). Der "AUS"-Wert wird stets berechnet und kann nicht definiert werden (beim Typ "HSV" wird z.B. nur der "V"-Anteil auf 0 gesetzt).

Die Eingänge E1..E5 werden mit absteigender Priorität behandelt, d.h. E1 hat die höchste und E5 die niedrigste Priorität. Wird z.B. E1 auf einen Lichtwert für "EIN" gesetzt (z.B. ein Dimmwert von 255) werden E2..E5 dadurch übersteuert (ignoriert). Erst wenn an E1 ein Lichtwert für "AUS" anliegt (z.B. 0) werden E2..E5 wieder freigegeben.

Der "Hauptschalter" (E7) hat Priorität vor allen Eingängen E1..E5 und arbeitet wie eine "Sicherung": Sobald E7 auf 0 gesetzt wird, wird A1 auf einen Lichtwert für "AUS" gesetzt (z.B. "0" oder "000000") und alle Telegramme an E1..E5 werden ignoriert (d.h. A1 bleibt dauerhaft "AUS"). Wird E7 auf 1 gesetzt, wird der ursprüngliche Zustand indirekt wiederhergestellt, d.h. alle Eingänge E1..E5 werden erneut verarbeitet und A1 entsprechend gesetzt.

<b>Hinweis:</b>
Dieser Baustein kann das Status-KO einer Leuchte <i>nicht</i> auswerten. Wenn die Leuchte zusätzlich über einen anderen Weg (ohne diesen Baustein) geschaltet wird, ist dem Baustein der aktuelle Zustand der Leuchte nicht bekannt - daher werden die Ausgänge A1..A7 u.U. nicht den tatsächlichen Zustand der Leuchte repräsentieren.


<h3>Besondere Funktionalitäten</h3>
<ul>
	<li>Mit E1 kann eine Alarmfunktion nachgebildet werden: Wird E1 auf einen Lichtwert für EIN gesetzt, wird A1 auf diesen Wert gesetzt - unabhängig von allen anderen Optionen (Energiesparmodus und Automatik werden ebenfalls ignoriert). Wird E1 auf "AUS" gesetzt, wird der ursprüngliche Zustand indirekt wiederhergestellt, d.h. alle Eingänge E2..E5 werden erneut verarbeitet und A1 entsprechend gesetzt.</li>
	<li>Mit Hilfe von E3 (Automatik) kann A1 automatisch auf einen EIN- oder AUS-Wert gesetzt werden - in Abhängigkeit vom Helligkeitsstatus an E9.</li>
	<li>Für E5 kann optional einer Timerfunktion aktiviert werden (E16&gt;0). Dies ermöglicht z.B. das direkte Verbinden von E5 mit einem Bewegungsmelder: Bei jedem Telegramm=1 an E5 wird der Timer neugestartet (retriggerbar) und A1 auf EIN gesetzt, nach Ablauf der definierten Dauer an E16 wird A1 auf AUS gesetzt.</li>
	<li>Mit E8 kann der Energiesparmodus aktiviert werden: Dieser sorgt dafür, dass eine Leuchte nur bei Dunkelheit eingeschaltet werden kann, ausserdem wird eine eingeschaltete Leuchte bei eintretender Helligkeit automatisch ausgeschaltet.</li>
	<li>Mit E10..E12 können E2, E4 und E5 aktiviert oder deaktiviert werden, z.B. um bestimmte Funktionen per Zeitschaltuhr freizugeben oder zu sperren.</li>
</ul>


<h3>Anwendungsbeispiele</h3>
Im einfachsten Fall kann dieser Baustein über ein internes KO an E2 die Funktion einer realen Leuchte (an A1) virtualisieren: An E2 wird der gewünschte Lichtwert angelegt und A1 wird in Abhängigkeit von weiteren Bedingungen (Dunkelheit, etc.) auf diesen Lichtwert gesetzt. Über eine Ausgangsbox kann A1 direkt auf die KNX-GA der entsprechenden Leuchte gelegt werden. Dieses Vorgehen ist auch für Szenen geeignet, d.h. die Szene setzt nicht direkt die KNX-GA - vielmehr wird ein internes KO auf den gewünschten Lichtwert gesetzt.

Zusätzlich kann nun z.B. die Automatik-Funktion C aktiviert werden (E3=1): Die Leuchte wird nun automatisch bei Dunkelheit eingeschaltet und bei Helligkeit ausgeschaltet. Ein "manuelles" Übersteuern ist dabei durch E2 jederzeit möglich, d.h. die Leuchte kann z.B. gezielt ausgeschaltet werden (E2=0) und wird erst beim nächsten Hell-/Dunkeltelegramm an E9 ggf. wieder automatisch eingeschaltet.

Bei Bedarf kann die Automatik-Funktion auch mit Hilfe einer Zeitschaltuhr aktiviert/deaktiviert werden, z.B. um die Leuchte bei Dunkelheit automatisch einzuschalten, jedoch z.B. um 23:00:00 Uhr trotz Dunkelheit wieder auszuschalten.

An D (E4) könnte z.B. ein Tür-/Fenterkontakt konnektiert werden, so dass die Leuchte beim Öffnen eines Fensters oder Terrassentür automatisch ein- oder ausgeschaltet wird (A/B/C haben dabei jedoch stets Priorität).

Mit Hilfe von E (E5) kann schließlich ein Bewegungsmelder zum Schalten der Leuchte genutzt werden, bei Bedarf kann die Timer-Funktion entsprechend aktiviert werden.

Mit höchster Priorität (abgesehen vom Hauptschalter E7) kann jederzeit die Alarmfunktion A (E1) genutzt werden: Im Falle einer Alarmierung wird die Leuchte auf den Lichtwert an E1 gesetzt - unabhängig von allen anderen Funktionen, d.h. auch bei Helligkeit(!). Dieser Zustand bleibt solange erhalten, bis E1 auf AUS gesetzt wird - der Baustein wird dann vollständig neu berechnet, die aktuellen Bedingungen (B/C/D/E, Helligkeit, etc.) werden also entsprechend berücksichtigt.


<h2>Ein- und Ausgänge</h2>
<h3>Trigger-Eingänge (absteigende Priorität)</h3>
<ul>
	<li>E1: A Lichtwert (Alarmfunktion)
		<ul>
			<li>EIN: setzt A1 auf den EIN-Wert an E2 und sperrt E2..E5</li>
			<li>Hinweis: Der Energiesparmodus (E8) wird bei EIN ignoriert, d.h. A1 wird stets auf den EIN-Wert an E2 gesetzt - auch bei Helligkeit.</li>
			<li>AUS: setzt A1 auf AUS, gibt E2..E5 frei und berechnet den Zustand des LBS neu</li>
			<li>Hinweis: AUS führt zur Neuberechnung des Zustands, d.h. je nach E2..E5 wird A1 auf EIN oder AUS gesetzt.</li>
		</ul>
	</li>

	<li>E2: B Lichtwert
		<ul>
			<li>EIN: setzt A1 auf den EIN-Wert an E2 und sperrt E3..E5</li>
			<li>AUS: setzt A1 auf AUS und gibt E3..E5 frei</li>
			<li>Hinweis: AUS führt nicht(!) zu einer Neuberechnung, damit A1 gezielt auf AUS gesetzt werden kann.</li>
		</ul>
	</li>

	<li>E3: C 0/1 (Automatik bzw. "Dämmerungsschalter") - dies ist eigentlich kein Trigger-Eingang, sondern eher eine "Option" (zur Verdeutlichung der Prioritäten ist dieser Eingang jedoch an dieser Stelle eingeordnet)
		<ul>
			<li>1: aktiviert die Automatik und sperrt E4+E5</li>
			<li>0: deaktiviert die Automatik, A1 wird auf AUS gesetzt und E4..E5 werden freigegeben</li>
			<li>Hinweis: Bei aktivierter Automatik wird A1 bei Dunkelheit automatisch auf den EIN-Wert an E13 gesetzt und bei Helligkeit auf AUS.</li>
			<li>Wichtig: Die Automatik-Funktion kann nur genutzt werden, wenn an E9 ein entsprechender Wert 0/1 für hell/dunkel anliegt!</li>
		</ul>
	</li>

	<li>E4: D 0/1 (z.B. für einen Fensterkontakt)
		<ul>
			<li>1: setzt A1 auf den EIN-Wert an E14 und sperrt E5</li>
			<li>0: setzt A1 auf AUS und gibt E5 frei</li>
			<li></li>
		</ul>
	</li>

	<li>E5: E 0/1 (z.B. für einen Bewegungsmelder, optional mit Timerfunktion)
		<ul>
			<li>1: setzt A1 auf den EIN-Wert an E15</li>
			<li>0: setzt A1 auf AUS, sofern E16=0 ist (deaktivierte Timerfunktion)</li>
			<li>Hinweis: Ist die Timerfunktion aktiviert (E16&gt;0), wird der Timer mit E5=1 ggf. erneut getriggert ("verlängert"). E5=0 wird vollständig ignoriert!</li>
		</ul>
	</li>
</ul>


<h3>Einstellungen und Optionen</h3>
<ul>
	<li>E6: Typ des Lichtwertes (diese Angabe ist wichtig!)
		<ul>
			<li>0: Binär (1/0, also Ein/Aus)</li>
			<li>1: Dimmwert (0..255)</li>
			<li>2: RGB-Wert (000000..FFFFFF)</li>
			<li>3: HSV-Wert (000000..FFFFFF)</li>
		</ul>
	</li>

	<li>E7: Hauptschalter (0/1): Verhält sich quasi wie eine "Sicherung".
		<ul>
			<li>0: A1 wird dauerhaft auf AUS gesetzt, E1..E5 werden ignoriert (die virtuelle "Stromzufuhr" wird quasi unterbrochen)</li>
			<li>1: der Zustand des LBS wird neuberechnet, A1 wird auf den entsprechenden Wert gesetzt</li>
		</ul>
	</li>

	<li>E8: Energiesparmodus (0/1)
		<ul>
			<li>0: Deaktiviert, d.h. A1 wird unabhängig von E9 (hell/dunkel) gesetzt</li>
			<li>1: Aktiviert, d.h. A1 wird nur dann auf einen EIN-Wert gesetzt, wenn E9=1 ist (dunkel). Ausserdem wird A1 bei E9=0 (hell) automatisch auf AUS gesetzt, um z.B. eine versehentlich eingeschaltete Leuchte bei Tagesanbruch auszuschalten.</li>
			<li>Hinweis: A1 wird bei jedem Aktivieren des Energiesparmodus auf AUS gesetzt, sofern E9=0 ist (hell).</li>
			<li>Wichtig: Der Energiesparmodus wird für E1 (Alarmfunktion) ignoriert!</li>
			<li>Wichtig: Der Energiesparmodus kann nur genutzt werden, wenn an E9 ein entsprechender Wert 0/1 für hell/dunkel anliegt!</li>
		</ul>
	</li>

	<li>E9: Helligkeit/Dunkelheit: Status z.B. eines Dämmerungssensors 
		<ul>
			<li>0: Hell</li>
			<li>1: Dunkel</li>
			<li>Hinweis: Dieser Status wird für den Energiesparmodus (E8) und für die Automatik (E3) benötigt. Ist E9=[leer], stehen Energiesparmodus und Automatik nicht zu Verfügung.</li>
		</ul>
	</li>
</ul>


<h3>Konfiguration von B..E</h3>
<ul>
	<li>E10: Aktivierung von B: 0=Deaktiviert, 1=Aktiviert
		<ul>
			<li>Hinweis: Eine Aktivierung/Deaktivierung führt zu keiner Änderung von A1.</li>
		</ul>
	</li>

	<li>E11: Aktivierung von D: 0=Deaktiviert, 1=Aktiviert
		<ul>
			<li>eine Aktivierung ist nur möglich, wenn an E14 ein gültiger EIN-Wert angegeben ist</li>
			<li>Hinweis: Eine Aktivierung/Deaktivierung führt zu keiner Änderung von A1.</li>
		</ul>
	</li>

	<li>E12: Aktivierung von E: 0=Deaktiviert, 1=Aktiviert
		<ul>
			<li>eine Aktivierung ist nur möglich, wenn an E15 ein gültiger EIN-Wert angegeben ist</li>
			<li>Hinweis: Eine Aktivierung/Deaktivierung führt zu keiner Änderung von A1.</li>
		</ul>
	</li>

	<li>E13: Lichtwert für C: EIN-Wert zur Verwendung mit C
		<ul>
			<li>Hinweis: Der AUS-Wert wird automatisch berechnet.</li>
			<li>Wichtig: Ohne die Angabe eines gültigen EIN-Wertes kann C nicht genutzt werden.</li>
		</ul>
	</li>

	<li>E14: Lichtwert für D: EIN-Wert zur Verwendung mit D
		<ul>
			<li>Hinweis: Der AUS-Wert wird automatisch berechnet.</li>
			<li>Wichtig: Ohne die Angabe eines gültigen EIN-Wertes kann D nicht genutzt werden.</li>
		</ul>
	</li>

	<li>E15: Lichtwert für E: EIN-Wert zur Verwendung mit E
		<ul>
			<li>Hinweis: Der AUS-Wert wird automatisch berechnet.</li>
			<li>Wichtig: Ohne die Angabe eines gültigen EIN-Wertes kann E nicht genutzt werden.</li>
		</ul>
	</li>

	<li>E16: Timer-Dauer in Sekunden für E
		<ul>
			<li>0=Timer deaktivieren, d.h. E verhält sich wie D</li>
			<li>1..&infin;=Timer mit dieser Dauer (in Sekunden) aktivieren</li>
			<li>Hinweis: Bei aktiviertem Timer wird der Timer bei jedem neuen Telegramm=1 an E5 erneut gestartet (retriggerbar) - Telegramme&ne;1 werden dann ignoriert.</li>
		</ul>
	</li>
</ul>


<h3>Ausgänge</h3>
<ul>
	<li>A1: Lichtwert: an diesem Ausgang wird der aktuelle Lichtwert zur Übergabe an ein Schalt-/Dimm-KO ausgegeben
		<ul>
			<li>Hinweis: A1 wird nur bei einer Änderung des Lichtwertes gesetzt.</li>
		</ul>
	</li>

	<li>A2: Status: 0=der Lichtwert an A1 repräsentiert einen AUS-Wert, 1=der Lichtwert an A1 repräsentiert einen EIN-Wert
		<ul>
			<li>Hinweis: A2 wird bei <i>jeder</i> Änderung von A1 (also des Lichtwertes) gesetzt.</li>
		</ul>
	</li>

	<li>A3..A7: Status A..E: diese Ausgänge werden in Abhängigkeit von A2 auf 0 oder 1 gesetzt (0=AUS, 1=EIN)
		<ul>
			<li>A3..A7 repräsentieren jeweils den Zustand genau des Kanals A..E, der für den aktuellen Status an A2 verantwortlich ist</li>
			<li>daher kann stets maximal einer der Ausgänge A3..A7 den Wert 1 annehmen, da bedingt durch die Priorisierung stets nur ein Kanal A..E für den aktuellen Status an A2 verantwortlich sein kann</li>
			<li>A3..A7 zeigen demnach an, welcher Kanal A..E für den aktuellen EIN-Zustand von A1 bzw. A2 verantwortlich ist</li>
			<li>Tipp: Diese Ausgänge eignen sich z.B. für die Ansteuerung einer Status-LED, um anzuzeigen ob die Leuchte z.B. manuell (Taster) oder per Bewegungsmelder eingeschaltet wurde.</li>
			<li>Hinweis: Die einzelnen Ausgänge werden nur bei einer Änderung des jeweiligen Zustands gesetzt.</li>
			<li>Wichtig: Der Wert 0 an einem der Ausgänge A3..A7 bedeutet nicht zwangsläufig, dass ein AUS-Lichtwert an A1 anliegt - eine 0 bedeutet lediglich, dass der entsprechende Kanal nicht für einen EIN-Lichtwert verantwortlich ist. Nur wenn <i>alle</i> Ausgänge A3..A7 den Wert 0 haben, liegt an A1 ein AUS-Lichtwert an (bzw. A2 ist 0).</li>
		</ul>
	</li>
</ul>

###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {

	if (($E=logic_getInputs($id)) && ($V=logic_getVars($id))) {

		//Typ ggf. auf Default=0 setzen
		if (!($E[6]['value']==0 || $E[6]['value']==1 || $E[6]['value']==2 || $E[6]['value']==3)) {$E[6]['value']=0;}

		//Energiesparmodus: deaktivieren wenn E7=(leer)
		if (isEmpty($E[9]['value'])) {$E[8]['value']=0;}

		//C deaktivieren wenn E9=(leer) oder Lichtwert!=EIN
		if (isEmpty($E[9]['value']) || LB_LBSID_isOnValue($E[5]['value'],$E[13]['value'])===false) {$E[3]['value']=0;}

		//D deaktivieren wenn Lichtwert!=EIN
		if (LB_LBSID_isOnValue($E[5]['value'],$E[14]['value'])===false) {$E[11]['value']=0;}

		//E deaktivieren wenn Lichtwert!=EIN
		if (LB_LBSID_isOnValue($E[5]['value'],$E[15]['value'])===false) {$E[12]['value']=0;}


		//Status: Typenkonvertierung
		$V[2]=intval($V[2]);
		$V[3]=intval($V[3]);

		//Soll-Wert für A1 (für SBC)
		$A1value=null;
		
		


		//Hauptschalter (1)
		//----------------------------------------------------------
		if ($E[7]['refresh']==1) {		
			if ($E[7]['value']==1) {	//Aktiviert
				$E=LB_LBSID_refreshAll($E);
				$V[2]|=1;
			} else {	//Deaktiviert: AUS
				$r=LB_LBSID_switchOnOff($id,$E,0);
				if ($r[0]!==false) {$A1value=$r[1];}
				$V[2]=0;
			}
		}

		//A (2)
		//----------------------------------------------------------
		if ($V[2]&1) {	//Freigabe?
			if ($E[1]['refresh']==1) {		//Lichtwert wurde gesetzt
				$r=LB_LBSID_switchOnOff($id,$E,$E[1]['value'],true);	//Energiesparmodus unterdrücken
				if ($r[0]!==false) {$A1value=$r[1];}
				if ($r[0]==1) {
					$V[2]|=2;
				} else if ($r[0]==0) {
					$E=LB_LBSID_refreshAll($E);
					$V[2]&=~2;
				}
			}
		}

		//Energiesparmodus
		//----------------------------------------------------------
		if ($V[2]&1 && ~$V[2]&2) {	//Freigabe?
			if ($E[8]['value']==1) {			//Aktiviert
				if ($E[9]['refresh']==1 || $E[8]['refresh']==1) {	//E7 (hell/dunkel) wurde gesetzt oder Aktivierung
					if ($E[9]['value']==0) {	//Hell: AUS
						$r=LB_LBSID_switchOnOff($id,$E,0);
						if ($r[0]!==false) {$A1value=$r[1];}
					}
				}
			}
		}

		//B (4)
		//----------------------------------------------------------
		if ($V[2]&1 && ~$V[2]&2) {	//Freigabe?
			if ($E[10]['value']==1) {			//Aktiviert
				if ($E[2]['refresh']==1) {		//Lichtwert wurde gesetzt
					$r=LB_LBSID_switchOnOff($id,$E,$E[2]['value']);
					if ($r[0]!==false) {$A1value=$r[1];}
					if ($r[0]==1) {
						$V[2]|=4;
					} else if ($r[0]==0) {
						$V[2]&=~4;
					}
				}
			} else if ($E[10]['refresh']==1) {	//Deaktivierung
				$V[2]&=~4;
			}
		}

		//C (8)
		//----------------------------------------------------------
		if ($V[2]&1 && ~$V[2]&2 && ~$V[2]&4) {	//Freigabe?
			if ($E[3]['value']==1) {			//Aktiviert
				if ($E[9]['refresh']==1 || $E[3]['refresh']==1) {	//E7 (hell/dunkel) wurde gesetzt oder Aktivierung
					if ($E[9]['value']==1) {	//Dunkel: EIN
						$r=LB_LBSID_switchOnOff($id,$E,$E[13]['value']);
						if ($r[0]!==false) {$A1value=$r[1];}
						$V[2]|=8;
					} else {					//Hell: AUS
						$r=LB_LBSID_switchOnOff($id,$E,0);
						if ($r[0]!==false) {$A1value=$r[1];}
						$V[2]&=~8;
					}
				}
			} else if ($E[3]['refresh']==1) {	//Deaktivierung: AUS und B+C freigeben
				$r=LB_LBSID_switchOnOff($id,$E,0);
				if ($r[0]!==false) {$A1value=$r[1];}
				$V[2]&=~8;
			}
		}

		//D (16)
		//----------------------------------------------------------
		if ($V[2]&1 && ~$V[2]&2 && ~$V[2]&4 && ~$V[2]&8) {	//Freigabe?
			if ($E[11]['value']==1) {			//Aktiviert
				if ($E[4]['refresh']==1) {		//Wert (0/1) wurde gesetzt
					if ($E[4]['value']==1) {$r=LB_LBSID_switchOnOff($id,$E,$E[14]['value']);} else {$r=LB_LBSID_switchOnOff($id,$E,0);}
					if ($r[0]!==false) {$A1value=$r[1];}
					if ($r[0]==1) {
						$V[2]|=16;
					} else if ($r[0]==0) {
						$V[2]&=~16;
					}
				}
			} else if ($E[11]['refresh']==1) {	//Deaktivierung
				$V[2]&=~16;
			}
		}

		//E (32)
		//----------------------------------------------------------
		if ($V[2]&1 && ~$V[2]&2 && ~$V[2]&4 && ~$V[2]&8 && ~$V[2]&16) {	//Freigabe?
			if ($E[12]['value']==1) {			//Aktiviert
				if ($E[5]['refresh']==1) {		//Wert (0/1) wurde gesetzt
				
					if ($E[16]['value']>0) {
						//Timer
						if ($E[5]['value']==1) {
							//Timer (re)triggern und EIN (Ausgänge sind ja SBC)
							$r=LB_LBSID_switchOnOff($id,$E,$E[15]['value']);
							if ($r[0]!==false) {$A1value=$r[1];}
							if ($r[0]==1) {
								$V[4]=(getMicrotime()+$E[16]['value']);
								logic_setVar($id,4,$V[4]);
								logic_setState($id,1,$E[16]['value']*1000);
								$V[2]|=32;
							}
						}
					
					} else {
						//kein Timer
						if ($E[5]['value']==1) {$r=LB_LBSID_switchOnOff($id,$E,$E[15]['value']);} else {$r=LB_LBSID_switchOnOff($id,$E,0);}
						if ($r[0]!==false) {$A1value=$r[1];}
						if ($r[0]==1) {
							$V[2]|=32;
						} else if ($r[0]==0) {
							$V[2]&=~32;
						}
					}
				
				}
			} else if ($E[12]['refresh']==1) {	//Deaktivierung
				$V[2]&=~32;
			}
		}
		
		if (logic_getState($id)!=0) {	//Timer läuft
			if (getMicrotime()>=$V[4]) { //Zeit abgelaufen?
				if ($V[2]&1 && ~$V[2]&2 && ~$V[2]&4 && ~$V[2]&8 && ~$V[2]&16) {	//Freigabe?
					$r=LB_LBSID_switchOnOff($id,$E,0);
					if ($r[0]!==false) {$A1value=$r[1];}
				}
				$V[2]&=~32;
				logic_setState($id,0);
			}		
		}




		//A1+A2 (SBC)
		if (!isEmpty($A1value) && (string)strtoupper($A1value)!==(string)strtoupper($V[1])) {
			$V[1]=$A1value;
			logic_setVar($id,1,$V[1]);
			logic_setOutput($id,1,$V[1]);
			if (LB_LBSID_isOnValue($E[5]['value'],$V[1])!==false) {
				logic_setOutput($id,2,1);
			} else {
				logic_setOutput($id,2,0);
			}
		}

		//A3..A7 (SBC)
		$tmp=LB_LBSID_getStatus($E[5]['value'],$V[1],$V[2]);
		if ($tmp!=$V[3]) {
			if ($V[3]<0 || (($tmp&2)?1:0)!=(($V[3]&2)?1:0)) {logic_setOutput($id,3,(($tmp&2)?1:0));}
			if ($V[3]<0 || (($tmp&4)?1:0)!=(($V[3]&4)?1:0)) {logic_setOutput($id,4,(($tmp&4)?1:0));}
			if ($V[3]<0 || (($tmp&8)?1:0)!=(($V[3]&8)?1:0)) {logic_setOutput($id,5,(($tmp&8)?1:0));}
			if ($V[3]<0 || (($tmp&16)?1:0)!=(($V[3]&16)?1:0)) {logic_setOutput($id,6,(($tmp&16)?1:0));}
			if ($V[3]<0 || (($tmp&32)?1:0)!=(($V[3]&32)?1:0)) {logic_setOutput($id,7,(($tmp&32)?1:0));}
			logic_setVar($id,3,$tmp);
		}

		//Status sichern
		logic_setVar($id,2,$V[2]);
	}
}

function LB_LBSID_getStatus($typ,$value,$status) {
	$n=0;
	if (LB_LBSID_isOnValue($typ,$value)!==false) { //nur wenn EIN
		if ($status&2) {$n=2;}
		else if ($status&4) {$n=4;}
		else if ($status&8) {$n=8;}
		else if ($status&16) {$n=16;}
		else if ($status&32) {$n=32;}
	}
	return $n;
}

function LB_LBSID_refreshAll($E) {
	$E[2]['refresh']=1;
	$E[4]['refresh']=1;
	$E[5]['refresh']=1;
	$E[1]['refresh']=1;
	$E[9]['refresh']=1;
	$E[3]['refresh']=1;
	$E[8]['refresh']=1;
	if ($E[8]['value']!=1) {$E[8]['refresh']=0;}
	if ($E[3]['value']!=1) {$E[3]['refresh']=0;}
	if ($E[11]['value']!=1) {$E[11]['refresh']=0;}
	if ($E[12]['value']!=1) {$E[12]['refresh']=0;}
	return $E;
}

function LB_LBSID_isOnValue($typ,$value) {
	//prüft, ob Lichtwert EIN oder AUS repräsentiert und gibt ggf. einen korrigierten Lichtwert für EIN zurück
	//return: Lichtwert=EIN (Lichtwert wird ggf. korrigiert), false=AUS
	if ($typ==0) {
		if ($value>=1) {return 1;}
	} else if ($typ==1) {
		if ($value>=1) {
			if ($value>255) {$value=255;}
			return intVal($value);
		}
	} else if ($typ==2) {
		if (strlen($value)==6) {
			$r=hexdec(substr($value,0,2));
			$g=hexdec(substr($value,2,2));
			$b=hexdec(substr($value,4,2));
			if (($r+$g+$b)>0) {
				return sprintf("%02X",round($r)).sprintf("%02X",round($g)).sprintf("%02X",round($b));
			}
		}
	} else if ($typ==3) {
		if (strlen($value)==6) {
			$h=hexdec(substr($value,0,2));
			$s=hexdec(substr($value,2,2));
			$v=hexdec(substr($value,4,2));
			if ($v>0) {
				return sprintf("%02X",round($h)).sprintf("%02X",round($s)).sprintf("%02X",round($v));
			}
		}
	}
	return false;
}

function LB_LBSID_getOffValue($typ,$value) {
	//gibt einen gültigen Lichtwert für AUS zurück (bei HSV wird nur V=00 gesetzt)
	//return: Lichtwert für AUS
	if ($typ==0) {
		return 0;
	} else if ($typ==1) {
		return 0;
	} else if ($typ==2) {
		return '000000';
	} else if ($typ==3) {
		if (strlen($value)==6) {
			$h=hexdec(substr($value,0,2));
			$s=hexdec(substr($value,2,2));
			$v=hexdec(substr($value,4,2));
			return sprintf("%02X",round($h)).sprintf("%02X",round($s)).'00';
		}
		return '000000';
	}
}

function LB_LBSID_switchOnOff($id,$E,$value,$ignoreEnergymode=false) {
	//A1 auf Lichtwert $value setzen (SBC mit V1), Energiesparmodus dabei ggf. berücksichtigen
	//Return: 1=Lampe wurde eingeschaltet (unabhängig von SBC), 0=Lampe wurde ausgeschaltet (unabhängig von SBC), false=Lampe wurde nicht eingeschaltet (Energiesparmodus)

	$light=LB_LBSID_isOnValue($E[6]['value'],$value);
	if ($light!==false) {
		//Einschalten
		if ($ignoreEnergymode || $E[8]['value']==0 || $E[9]['value']==1) {		//Energiesparmodus=aus/ignore oder Dunkelheit?
			return array(1,$light);
		} else {
			return array(false,false);
		}
	} else {
		//Ausschalten
		$light=LB_LBSID_getOffValue($E[6]['value'],$value);
		return array(0,$light);
	}
}

?>
###[/LBS]###


###[EXEC]###
<?

?>
###[/EXEC]###
