<?
/* 
 * EDOMI beta (Version 1.56) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
/*
-----------------------------------------------------------------------------------------------------------------------------------------
Controltyp 20 - Kamera (Livebild und Archiv)
-----------------------------------------------------------------------------------------------------------------------------------------
*/
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");
require(MAIN_PATH."/www/shared/php/incl_camera.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");


sql_connect();

if (checkVisuSid($visuId,$sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$sid;
	global $global_weekdays;

	if ($cmd=='camLive') {

		if ($dataArr[2]==-1) {
			//direktes MJPEG-Streaming
			$url=sql_getValue('edomiLive.cam','url','id='.$dataArr[1].' AND mjpeg=1');
?>
			control20_callbackLiveStream(<?echo $dataArr[0];?>,"<?ajaxValue($url);?>");
<?
		} else {
			//Einzelbild
			$img=getVisuLiveCamImg($dataArr[1]);
			if ($img!==false) {
?>
				control20_callbackLiveFrame(<?echo $dataArr[0];?>,"../data/liveproject/cam/live/<?echo $img;?>?ts=<?echo getTimestampId();?>");
<?
			} else {
?>
				control20_callbackLiveFrame(<?echo $dataArr[0];?>,"");
<?
			}
		}
	}


	if ($cmd=='camArchiv') {
		$archivName=sql_getValue('edomiLive.archivCam','name','id='.$dataArr[4]);
		if (isEmpty($archivName)) {$archivName='???';}

		//mode=1: vor, =-1: zurück, 0=aktuellster Eintrag
		if ($dataArr[1]==0) { //aktuellsten Eintrag (dies ist Default beim Öffnen)
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4].") ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==1) { //Navigation: Älteres Bild
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))<'".$dataArr[2]."') ORDER BY datetime DESC,ms DESC LIMIT 0,1");
		}
		if ($dataArr[1]==-1) { //Navigation: Jüngeres Bild
			$ss1=sql_call("SELECT * FROM edomiLive.archivCamData WHERE (targetid=".$dataArr[4]." AND CONCAT(datetime,LPAD(ms,6,'0'))>'".$dataArr[2]."') ORDER BY datetime ASC,ms ASC LIMIT 0,1");
		}

		if ($n=sql_result($ss1)) {
			$fn=getArchivCamFilename($n['targetid'],$n['camid'],$n['datetime'],$n['ms']).'.jpg';

			if ($dataArr[5]==0) {$tmp=sql_getDateTime($n['datetime']);}
			else if ($dataArr[5]==1) {$tmp=sql_getDateTime($n['datetime'])."<span style='opacity:0.75;'>.".sprintf("%06d",$n['ms'])."</span>";}
			else if ($dataArr[5]==2) {$tmp=$global_weekdays[date('N',strtotime($n['datetime']))-1]." / ".sql_getDateTime($n['datetime']);}
			else if ($dataArr[5]==3) {$tmp=$global_weekdays[date('N',strtotime($n['datetime']))-1]." / ".sql_getDateTime($n['datetime'])."<span style='opacity:0.75;'>.".sprintf("%06d",$n['ms'])."</span>";}

			if (file_exists(MAIN_PATH.'/www/data/liveproject/cam/archiv/'.$fn)) {
?>  
				control20_callbackArchivLoaded(<?echo $dataArr[0];?>,"<?echo ajaxValueHTML($archivName);?><br><?echo $tmp;?>","../data/liveproject/cam/archiv/<?echo $fn;?>?ts=<?echo getTimestampId();?>","<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>",true);
<?
			} else {
?>
				control20_callbackArchivLoaded(<?echo $dataArr[0];?>,"<?echo ajaxValueHTML($archivName);?><br><?echo $tmp;?>","","<?echo ($n['datetime'].sprintf("%06d",$n['ms']));?>",false);
<?
			}
		} else {
			$anz=sql_getCount('edomiLive.archivCamData',"targetid=".$dataArr[4]);
?>
			control20_callbackArchivLoaded(<?echo $dataArr[0];?>,"<?echo ajaxValueHTML($archivName);?>","<?echo $anz;?>","",false);
<?
		}
		sql_close($ss1);
	}
}

sql_disconnect();
?>

