/* 
 * EDOMI beta (Version 1.56) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 10 (Tastatureingabe)
//----------------------------

function control10_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='left:0; top:0; width:100%; height:100%;'>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
			n+="<tr id='e-"+item.id+"-mode1'><td><span id='e-"+item.id+"-text'></span></td></tr>";
			n+="<tr id='e-"+item.id+"-mode2' style='display:none;'><td><input id='e-"+item.id+"-edit' type='"+((obj.dataset.var1==0)?"text":"password")+"' value='' onBlur='control10_Cancel(\""+item.id+"\");' on"+downEvent+"='clickCancel();' onKeyUp='control10_KeyDown(\""+item.id+"\")' class='controlInput' style='left:0; top:0; background:"+visu_indiColor+"; color:"+visu_indiColorText+";'></td></tr>";
		n+="</table>";
	n+="</div>";
	obj.innerHTML=n;

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control10_Start(item.id);},false);
}

function control10_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
}

function control10_Start(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {

		var kovalue=getKoValue(d);
		resetKoValue_Interval(kovalue);
		d.dataset.sended=0;

		document.getElementById("e-"+elementId+"-mode1").style.display="none";
		document.getElementById("e-"+elementId+"-mode2").style.display="table-row";
		document.getElementById("e-"+elementId+"-edit").value=kovalue;
		 //Focus und Preselect (brauchen eine Verzögerung)
		if (d.dataset.var2==1) {
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-edit")) {document.getElementById("e-"+elementId+"-edit").focus(); document.getElementById("e-"+elementId+"-edit").select();}},250);
		} else {
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-edit")) {document.getElementById("e-"+elementId+"-edit").focus();}},250);
		}
	}
}

function control10_KeyDown(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);
	var obj=document.getElementById("e-"+elementId+"-edit");
	if (d && obj) {
		element_drag.koeditvalue=control10_CheckRange(elementId,obj.value);
		setKoValue_Interval(elementId,true,d.dataset.var4);

		if (event.keyCode==13) {control10_Send(elementId);}
	}
}

function control10_Send(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.sended=1;
		setKoValue_Interval(elementId,false);

		document.getElementById("e-"+elementId+"-mode1").style.display="table-row";
		document.getElementById("e-"+elementId+"-mode2").style.display="none";
		document.getElementById("e-"+elementId+"-edit").blur();
	}
}

function control10_Cancel(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.sended==0) {
			setLiveValue(elementId,false);
			document.getElementById("e-"+elementId+"-mode1").style.display="table-row";
			document.getElementById("e-"+elementId+"-mode2").style.display="none";
		}
	}
}

function control10_CheckRange(elementId,value) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		//nummerischer Wert gefordert?
		var vmin=parseFloat(d.dataset.var5);
		var vmax=parseFloat(d.dataset.var6);
		if (!isNaN(vmin) && !isNaN(vmax)) {

//### ab hier: globale Funktion? (für Slider, etc.)
			value=parseFloat(value);

			if (isNaN(value) || value<vmin) {value=vmin;}
			if (value>vmax) {value=vmax;}

			var vstep=parseFloat(d.dataset.var7);
			if (!isNaN(vstep) && vstep!=0) {value=Math.round(value/vstep)*vstep;}
			
			var vlist=parseInt(d.dataset.var8);
			if (vlist>=0) {value=value.toFixed(vlist);}
		}
	}
	return value;
}
