/* 
 * EDOMI beta (Version 1.56) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 11 (Drehregler)
//----------------------------

function control11_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
		if (obj.dataset.var2&1) {
			n+="<div id='e-"+item.id+"-deco1' style='position:absolute; box-sizing:border-box; border:1px solid; "+((obj.dataset.var1&4)?"border-bottom-color:transparent; ":"")+"border-radius:100%; background:transparent; pointer-events:none;'></div>";
			n+="<div id='e-"+item.id+"-deco2' style='position:absolute; box-sizing:border-box; pointer-events:none;'>";
				n+="<div style='display:block; margin-left:auto; margin-right:auto; width:0px; height:15%; border:1px solid;'></div>";
			n+="</div>";
		}
		if (obj.dataset.var2&4) {n+="<div id='e-"+item.id+"-editvalue' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+";'></div>";}
		n+="<div id='e-"+item.id+"-cursor1' style='display:none; position:absolute; box-sizing:border-box; border-radius:100%; border:2px solid "+visu_indiColor+"; "+((obj.dataset.var1&4)?"border-bottom-color:transparent;":"")+"'></div>";
		n+="<div id='e-"+item.id+"-cursor2' style='display:none; position:absolute; box-sizing:border-box;'>";
			n+="<div style='display:block; margin-left:auto; margin-right:auto; width:2px; height:15%; background:"+visu_indiColor+";'></div>";
		n+="</div>";
	n+="</div>";
	obj.innerHTML=n;

	if (isNaN(parseFloat(obj.dataset.var5)) || isNaN(parseFloat(obj.dataset.var6))) {
		obj.dataset.var5=0;
		obj.dataset.var6=100;
	}

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control11_Start(item.id);},false);
}

function control11_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control11_Init(obj.dataset.id);
}

function control11_Init(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.var2&1) {
		var kovalue=getKoValue(d);
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco1"));
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco2"));

		//Knopf
		var tmp=element_getDefaultPosition(kovalue,d.dataset.var5,d.dataset.var6,((d.dataset.var1&4)?45:0),((d.dataset.var1&4)?315:360));
		if (tmp!==false) {document.getElementById("e-"+elementId+"-deco2").style.webkitTransform="rotate("+(tmp-180)+"deg)";}
	}
}

function control11_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	var kovalue=getKoValue(d);
	element_drag.id=elementId;
	resetKoValue_Interval(((d.dataset.var1&2)?"":kovalue));

	if (d.dataset.var2&1 && d.dataset.var2&2 && !(d.dataset.var1&1)) {
		document.getElementById("e-"+elementId+"-deco1").style.display="none";
		document.getElementById("e-"+elementId+"-deco2").style.display="none";
	}
	if (d.dataset.var2&2) {
		document.getElementById("e-"+elementId+"-cursor1").style.display="block";
		document.getElementById("e-"+elementId+"-cursor2").style.display="block";
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-cursor1"));
		element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-cursor2"));
	}
	if (d.dataset.var2&4) {
		document.getElementById("e-"+elementId+"-text").style.display="none";
		document.getElementById("e-"+elementId+"-editvalue").style.display="block";
	}
	
	//KO parsen und Startposition merken
	var canvas=document.getElementById("e-"+elementId+"-container");
	getMouseValue(d,canvas,true,kovalue,1,1,null,d.dataset.var5,d.dataset.var6,null,null,((d.dataset.var1&4)?45:0),((d.dataset.var1&4)?315:360),d.dataset.var8,d.dataset.var7,((d.dataset.var1&8)?15:5));						

	control11_Move();

	window.addEventListener(moveEvent,control11_Move,false);
	window.addEventListener(upEvent,control11_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}

}

function control11_Move() {
	if (!event) var event=window.event;
	if (element_drag.id>0) {
		var d=document.getElementById("e-"+element_drag.id);
		if (d) {
			var canvas=document.getElementById("e-"+element_drag.id+"-container");

			var modus=((d.dataset.var1&2)?0:1);
			if (d.dataset.var1&1) {modus=2;}
			var pos=getMouseValue(d,canvas,false,null,1,1,modus,d.dataset.var5,d.dataset.var6,null,null,((d.dataset.var1&4)?45:0),((d.dataset.var1&4)?315:360),d.dataset.var8,d.dataset.var7,((d.dataset.var1&8)?15:5));						
			var value=pos.valuex;

			if (d.dataset.var2&2) {document.getElementById("e-"+element_drag.id+"-cursor2").style.webkitTransform="rotate("+(pos.cursorx-180)+"deg)";}
			if (d.dataset.var2&4) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.d_caption,value)+"</span></button>";}

			//KO setzen und Wert merken
			element_drag.koeditvalue=value;
			setKoValue_Interval(element_drag.id,true,d.dataset.var4);			
		}
	}
}

function control11_Send() {
	var d=document.getElementById("e-"+element_drag.id);
	if (d) {
		setKoValue_Interval(element_drag.id,false);

		document.getElementById("e-"+element_drag.id+"-text").style.display="inline";
		if (d.dataset.var2&1) {
			document.getElementById("e-"+element_drag.id+"-deco1").style.display="block";
			document.getElementById("e-"+element_drag.id+"-deco2").style.display="block";
		}
		if (d.dataset.var2&4) {document.getElementById("e-"+element_drag.id+"-editvalue").style.display="none";}
		document.getElementById("e-"+element_drag.id+"-cursor1").style.display="none";
		document.getElementById("e-"+element_drag.id+"-cursor2").style.display="none";
		
		element_drag.id=0;
		window.removeEventListener(moveEvent,control11_Move,false);
		window.removeEventListener(upEvent,control11_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}
	}
}
